Index: squid/src/ssl.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/ssl.c,v
retrieving revision 1.1.1.3.10.3.2.1
retrieving revision 1.1.1.3.10.3.2.2
diff -u -r1.1.1.3.10.3.2.1 -r1.1.1.3.10.3.2.2
--- squid/src/ssl.c	2 May 2000 22:50:29 -0000	1.1.1.3.10.3.2.1
+++ squid/src/ssl.c	14 May 2000 23:22:19 -0000	1.1.1.3.10.3.2.2
@@ -1,6 +1,6 @@
 
 /*
- * $Id: ssl.c,v 1.1.1.3.10.3.2.1 2000/05/02 22:50:29 hno Exp $
+ * $Id: ssl.c,v 1.1.1.3.10.3.2.2 2000/05/14 23:22:19 hno Exp $
  *
  * DEBUG: section 26    Secure Sockets Layer Proxy
  * AUTHOR: Duane Wessels
@@ -382,10 +382,10 @@
 	    sslState->servers->peer->host);
     else if (Config.onoff.log_ip_on_direct)
 	hierarchyNote(&sslState->request->hier, sslState->servers->code,
-		fd_table[sslState->server.fd].ipaddr);
+	    fd_table[sslState->server.fd].ipaddr);
     else
 	hierarchyNote(&sslState->request->hier, sslState->servers->code,
-		sslState->host);
+	    sslState->host);
     if (status == COMM_ERR_DNS) {
 	debug(26, 4) ("sslConnect: Unknown host: %s\n", sslState->host);
 	err = errorCon(ERR_DNS_FAIL, HTTP_NOT_FOUND);
@@ -428,14 +428,14 @@
     aclCheck_t ch;
     int answer;
     /*
-       * client_addr == no_addr indicates this is an "internal" request
-       * from peer_digest.c, asn.c, netdb.c, etc and should always
-       * be allowed.  yuck, I know.
-       */
+     * client_addr == no_addr indicates this is an "internal" request
+     * from peer_digest.c, asn.c, netdb.c, etc and should always
+     * be allowed.  yuck, I know.
+     */
     if (request->client_addr.s_addr != no_addr.s_addr) {
 	/*
-	   * Check if this host is allowed to fetch MISSES from us (miss_access)
-	   */
+	 * Check if this host is allowed to fetch MISSES from us (miss_access)
+	 */
 	memset(&ch, '\0', sizeof(aclCheck_t));
 	ch.src_addr = request->client_addr;
 	ch.my_addr = request->my_addr;
Index: squid/src/stat.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/stat.c,v
retrieving revision 1.1.1.3.10.4.2.1
retrieving revision 1.1.1.3.10.4.2.2
diff -u -r1.1.1.3.10.4.2.1 -r1.1.1.3.10.4.2.2
--- squid/src/stat.c	8 May 2000 18:02:08 -0000	1.1.1.3.10.4.2.1
+++ squid/src/stat.c	14 May 2000 23:22:19 -0000	1.1.1.3.10.4.2.2
@@ -1,6 +1,6 @@
 
 /*
- * $Id: stat.c,v 1.1.1.3.10.4.2.1 2000/05/08 18:02:08 hno Exp $
+ * $Id: stat.c,v 1.1.1.3.10.4.2.2 2000/05/14 23:22:19 hno Exp $
  *
  * DEBUG: section 18    Cache Manager Statistics
  * AUTHOR: Harvest Derived
@@ -277,8 +277,8 @@
 	if (mem->swapout.sio)
 	    storeAppendPrintf(s, "\tswapout: %d bytes written\n",
 		(int) storeOffset(mem->swapout.sio));
-        for (i = 0, node = mem->clients.head; node; node = node->next, i++) {
-            sc = (store_client *)node->data;
+	for (i = 0, node = mem->clients.head; node; node = node->next, i++) {
+	    sc = (store_client *) node->data;
 	    if (sc->callback_data == NULL)
 		continue;
 	    storeAppendPrintf(s, "\tClient #%d, %p\n", i, sc->callback_data);
Index: squid/src/store.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/store.c,v
retrieving revision 1.1.1.3.10.8.2.3
retrieving revision 1.1.1.3.10.8.2.4
diff -u -r1.1.1.3.10.8.2.3 -r1.1.1.3.10.8.2.4
--- squid/src/store.c	8 May 2000 18:02:08 -0000	1.1.1.3.10.8.2.3
+++ squid/src/store.c	14 May 2000 23:22:20 -0000	1.1.1.3.10.8.2.4
@@ -1,6 +1,6 @@
 
 /*
- * $Id: store.c,v 1.1.1.3.10.8.2.3 2000/05/08 18:02:08 hno Exp $
+ * $Id: store.c,v 1.1.1.3.10.8.2.4 2000/05/14 23:22:20 hno Exp $
  *
  * DEBUG: section 20    Storage Manager
  * AUTHOR: Harvest Derived
@@ -81,6 +81,8 @@
 static void destroy_MemObject(StoreEntry *);
 static FREE destroy_StoreEntry;
 static void storePurgeMem(StoreEntry *);
+static void storeEntryReferenced(StoreEntry *);
+static void storeEntryDereferenced(StoreEntry *);
 static int getKeyCounter(void);
 static int storeKeepInMemory(const StoreEntry *);
 static OBJH storeCheckCachableStats;
@@ -89,14 +91,6 @@
 /*
  * local variables
  */
-#if HEAP_REPLACEMENT
-/*
- * The heap equivalent of inmem_list, inmem_heap, is in globals.c so other
- * modules can access it when updating object metadata (e.g., refcount)
- */
-#else
-static dlink_list inmem_list;
-#endif
 int store_pages_max = 0;
 int store_swap_high = 0;
 int store_swap_low = 0;
@@ -226,23 +220,50 @@
 	storeRelease(e);
 }
 
-void
-storeLockObject(StoreEntry * e)
+static void
+storeEntryReferenced(StoreEntry *e)
 {
     SwapDir *SD;
 
-    if (e->swap_dirn > -1)
-      SD = INDEXSD(e->swap_dirn);
-    else
-      SD = NULL;
+    /* Notify the fs that we're referencing this object again */
+    if (e->swap_dirn > -1) {
+	SD = INDEXSD(e->swap_dirn);
+	if (SD->refobj)
+	    SD->refobj(SD, e);
+    }
+    /* Notify the memory cache that we're referencing this object again */
+    if(e->mem_obj) {
+	if (mem_policy->Referenced)
+	    mem_policy->Referenced(mem_policy, e, &e->mem_obj->repl);
+    }
+}
+
+static void
+storeEntryDereferenced(StoreEntry *e)
+{
+    SwapDir *SD;
 
+    /* Notify the fs that we're not referencing this object any more */
+    if (e->swap_filen > -1) {
+        SD = INDEXSD(e->swap_dirn);
+	if (SD->unrefobj != NULL)
+	    SD->unrefobj(SD, e);
+    }
+    /* Notify the memory cache that we're not referencing this object any more */
+    if(e->mem_obj) {
+	if (mem_policy->Dereferenced)
+	    mem_policy->Dereferenced(mem_policy, e, &e->mem_obj->repl);
+    }
+}
+
+void
+storeLockObject(StoreEntry * e)
+{
     e->lock_count++;
     debug(20, 3) ("storeLockObject: key '%s' count=%d\n",
 	storeKeyText(e->key), (int) e->lock_count);
     e->lastref = squid_curtime;
-    /* Notify the fs that we're referencing this object again */
-    if (SD != NULL && SD->refobj != NULL)
-        SD->refobj(SD, e);
+    storeEntryReferenced(e);
 }
 
 void
@@ -266,7 +287,6 @@
 int
 storeUnlockObject(StoreEntry * e)
 {
-    SwapDir *SD;
     e->lock_count--;
     debug(20, 3) ("storeUnlockObject: key '%s' count=%d\n",
 	storeKeyText(e->key), e->lock_count);
@@ -275,30 +295,16 @@
     if (e->store_status == STORE_PENDING)
 	EBIT_SET(e->flags, RELEASE_REQUEST);
     assert(storePendingNClients(e) == 0);
-    /* Notify the fs that we're not referencing this object any more */
-    if (e->swap_filen > -1)
-        SD = INDEXSD(e->swap_dirn);
-    else
-        SD = NULL;
-    if (SD != NULL && SD->unrefobj != NULL)
-        SD->unrefobj(SD, e);
-#if HEAP_REPLACEMENT
-    storeHeapPositionUpdate(e, SD);
-#else
-#if 0
-    /* Note: From 2.4. Not sure how this relates to the unrefobj() call above */
-    storeDirLRUDelete(e);
-    storeDirLRUAdd(e);
-#endif
-#endif
     if (EBIT_TEST(e->flags, RELEASE_REQUEST))
 	storeRelease(e);
     else if (storeKeepInMemory(e)) {
+	storeEntryDereferenced(e);
 	storeSetMemStatus(e, IN_MEMORY);
 	requestUnlink(e->mem_obj->request);
 	e->mem_obj->request = NULL;
     } else {
 	storePurgeMem(e);
+	storeEntryDereferenced(e);
 	if (EBIT_TEST(e->flags, KEY_PRIVATE))
 	    debug(20, 1) ("WARNING: %s:%d: found KEY_PRIVATE\n", __FILE__, __LINE__);
     }
@@ -371,7 +377,7 @@
      * If RELEASE_REQUEST is set, then ENTRY_CACHABLE should not
      * be set, and storeSetPublicKey() should not be called.
      */
-#if HEAP_REPLACEMENT
+#if MORE_DEBUG_OUTPUT
     if (EBIT_TEST(e->flags, RELEASE_REQUEST))
 	debug(20, 1) ("assertion failed: RELEASE key %s, url %s\n",
 	    e->key, mem->url);
@@ -541,7 +547,7 @@
 	return 0;		/* avoid release call below */
     } else if ((e->mem_obj->reply->content_length > 0 &&
 		e->mem_obj->reply->content_length > Config.Store.maxObjectSize) ||
-		e->mem_obj->inmem_hi > Config.Store.maxObjectSize) {
+	e->mem_obj->inmem_hi > Config.Store.maxObjectSize) {
 	debug(20, 2) ("storeCheckCachable: NO: too big\n");
 	store_check_cachable_hist.no.too_big++;
     } else if (e->mem_obj->reply->content_length > (int) Config.Store.maxObjectSize) {
@@ -676,16 +682,7 @@
     int released = 0;
     static time_t last_check = 0;
     int pages_needed;
-    int locked = 0;
-#if !HEAP_REPLACEMENT
-    dlink_node *head;
-    dlink_node *m;
-    dlink_node *prev = NULL;
-#else
-    heap_key age;
-    heap_key min_age = 0.0;
-    link_list *locked_entries = NULL;
-#endif
+    RemovalPurgeWalker *walker;
     if (squid_curtime == last_check)
 	return;
     last_check = squid_curtime;
@@ -693,57 +690,15 @@
     if (memInUse(MEM_STMEM_BUF) + pages_needed < store_pages_max)
 	return;
     debug(20, 2) ("storeGetMemSpace: Starting, need %d pages\n", pages_needed);
-#if HEAP_REPLACEMENT
-    while (heap_nodes(inmem_heap) > 0) {
-	age = heap_peepminkey(inmem_heap);
-	e = heap_extractmin(inmem_heap);
-	e->mem_obj->node = NULL;	/* no longer in the heap */
-	if (storeEntryLocked(e)) {
-	    locked++;
-	    debug(20, 5) ("storeGetMemSpace: locked key %s\n",
-		storeKeyText(e->key));
-	    linklistPush(&locked_entries, e);
-	    continue;
-	}
-	released++;
-	debug(20, 3) ("Released memory object with key %f size %d refs %d url %s\n",
-	    age, e->swap_file_sz, e->refcount, e->mem_obj->url);
-	min_age = age;
+    /* XXX what to set as max_scan here? */
+    walker = mem_policy->PurgeInit(mem_policy, 100000);
+    while((e = walker->Next(walker))) {
 	storePurgeMem(e);
-	if (memInUse(MEM_STMEM_BUF) + pages_needed < store_pages_max)
-	    break;
-    }
-    /*
-     * Increase the heap age factor.
-     */
-    if (min_age > 0)
-	inmem_heap->age = min_age;
-    /*
-     * Reinsert all bumped locked entries back into heap...
-     */
-    while ((e = linklistShift(&locked_entries)))
-	e->mem_obj->node = heap_insert(inmem_heap, e);
-#else
-    head = inmem_list.head;
-    for (m = inmem_list.tail; m; m = prev) {
-	if (m == head)
-	    break;
-	prev = m->prev;
-	e = m->data;
-	if (storeEntryLocked(e)) {
-	    locked++;
-	    dlinkDelete(m, &inmem_list);
-	    dlinkAdd(e, m, &inmem_list);
-	    continue;
-	}
 	released++;
-	storePurgeMem(e);
 	if (memInUse(MEM_STMEM_BUF) + pages_needed < store_pages_max)
 	    break;
     }
-#endif
-    debug(20, 3) ("storeGetMemSpace: released %d/%d locked %d\n",
-	released, hot_obj_count, locked);
+    walker->Done(walker);
     debug(20, 3) ("storeGetMemSpace stats:\n");
     debug(20, 3) ("  %6d HOT objects\n", hot_obj_count);
     debug(20, 3) ("  %6d were released\n", released);
@@ -765,15 +720,25 @@
 {
     int i;
     SwapDir *SD;
+    static time_t last_warn_time = 0;
 
     /* walk each fs */
     for (i = 0; i < Config.cacheSwap.n_configured; i++) {
 	/* call the maintain function .. */
 	SD = INDEXSD(i); 
+	/* XXX FixMe: This should be done "in parallell" on the different
+	 * cache_dirs, not one at a time.
+	 */
         if (SD->maintainfs != NULL)
 	    SD->maintainfs(SD);
     }
-
+    if (store_swap_size > Config.Swap.maxSize) {
+	if (squid_curtime - last_warn_time > 10) {
+	    debug(20, 0) ("WARNING: Disk space over limit: %d KB > %d KB\n",
+		store_swap_size, Config.Swap.maxSize);
+	    last_warn_time = squid_curtime;
+	}
+    }
     /* Reregister a maintain event .. */
     eventAdd("MaintainSwapSpace", storeMaintainSwapSpace, NULL, 1.0, 1);
 }
@@ -938,11 +903,9 @@
     storeInitHashValues();
     store_table = hash_create(storeKeyHashCmp,
 	store_hash_buckets, storeKeyHashHash);
+    mem_policy = createRemovalPolicy(Config.memPolicy);
     storeDigestInit();
     storeLogOpen();
-#if HEAP_REPLACEMENT
-    inmem_heap = new_heap(1000, HeapKeyGen_StoreEntry_GDSF);
-#endif
     stackInit(&LateReleaseStack);
     eventAdd("storeLateRelease", storeLateRelease, NULL, 1.0, 1);
     storeDirInit();
@@ -1126,35 +1089,24 @@
     assert(mem != NULL);
     if (new_status == IN_MEMORY) {
 	assert(mem->inmem_lo == 0);
-#if HEAP_REPLACEMENT
-	if (mem->node == NULL) {
-	    if (EBIT_TEST(e->flags, ENTRY_SPECIAL)) {
-		debug(20, 4) ("storeSetMemStatus: not inserting special %s\n",
-		    mem->url);
-	    } else {
-		mem->node = heap_insert(inmem_heap, e);
-		debug(20, 4) ("storeSetMemStatus: inserted mem node %p\n",
-		    mem->node);
-	    }
+	if (EBIT_TEST(e->flags, ENTRY_SPECIAL)) {
+	    debug(20, 4) ("storeSetMemStatus: not inserting special %s into policy\n",
+		mem->url);
+	} else {
+	    mem_policy->Add(mem_policy, e, &mem->repl);
+	    debug(20, 4) ("storeSetMemStatus: inserted mem node %s\n",
+		mem->url);
 	}
-#else
-	dlinkAdd(e, &mem->lru, &inmem_list);
-#endif
 	hot_obj_count++;
     } else {
-#if HEAP_REPLACEMENT
-	/*
-	 * It's being removed from the memory heap; is it already gone?
-	 */
-	if (mem->node) {
-	    heap_delete(inmem_heap, mem->node);
-	    debug(20, 4) ("storeSetMemStatus: deleted mem node %p\n",
-		mem->node);
-	    mem->node = NULL;
+	if (EBIT_TEST(e->flags, ENTRY_SPECIAL)) {
+		debug(20, 4) ("storeSetMemStatus: special entry %s\n",
+		    mem->url);
+	} else {
+	    mem_policy->Remove(mem_policy, e, &mem->repl);
+	    debug(20, 4) ("storeSetMemStatus: removed mem node %s\n",
+		mem->url);
 	}
-#else
-	dlinkDelete(&mem->lru, &inmem_list);
-#endif
 	hot_obj_count--;
     }
     e->mem_status = new_status;
@@ -1233,18 +1185,6 @@
     e->expires = e->lastmod = e->timestamp = -1;
 }
 
-#if HEAP_REPLACEMENT
-/*
- * This routine only handles memory updates these days
- */
-void
-storeHeapPositionUpdate(StoreEntry * e, SwapDir * SD)
-{
-    if (e->mem_obj && e->mem_obj->node)
-	heap_update(inmem_heap, e->mem_obj->node, e);
-}
-#endif
-
 /*
  * storeFsInit
  *
@@ -1269,7 +1209,7 @@
     int i = 0;
 
     while (storefs_list[i].typestr != NULL) {
-        storefs_list[i].donefunc();
+	storefs_list[i].donefunc();
 	i++;
     }
 }
@@ -1277,16 +1217,17 @@
 /*
  * called to add another store fs module
  */
-void storeFsAdd(char *type, STSETUP *setup)
+void
+storeFsAdd(char *type, STSETUP * setup)
 {
     int i;
     /* find the number of currently known storefs types */
     for (i = 0; storefs_list && storefs_list[i].typestr; i++) {
-	assert(strcmp(storefs_list[i].typestr, type)!=0);
+	assert(strcmp(storefs_list[i].typestr, type) != 0);
     }
     /* add the new type */
     storefs_list = xrealloc(storefs_list, (i + 2) * sizeof(storefs_entry_t));
-    memset(&storefs_list[i+1],0,sizeof(storefs_entry_t));
+    memset(&storefs_list[i + 1], 0, sizeof(storefs_entry_t));
     storefs_list[i].typestr = type;
     /* Call the FS to set up capabilities and initialize the FS driver */
     setup(&storefs_list[i]);
Index: squid/src/store_client.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/store_client.c,v
retrieving revision 1.1.1.3.10.4.2.2
retrieving revision 1.1.1.3.10.4.2.3
diff -u -r1.1.1.3.10.4.2.2 -r1.1.1.3.10.4.2.3
--- squid/src/store_client.c	8 May 2000 18:02:08 -0000	1.1.1.3.10.4.2.2
+++ squid/src/store_client.c	14 May 2000 23:22:20 -0000	1.1.1.3.10.4.2.3
@@ -1,6 +1,6 @@
 
 /*
- * $Id: store_client.c,v 1.1.1.3.10.4.2.2 2000/05/08 18:02:08 hno Exp $
+ * $Id: store_client.c,v 1.1.1.3.10.4.2.3 2000/05/14 23:22:20 hno Exp $
  *
  * DEBUG: section 20    Storage Manager Client-Side Interface
  * AUTHOR: Duane Wessels
@@ -59,7 +59,7 @@
     dlink_node *node;
     store_client *sc;
     for (node = mem->clients.head; node; node = node->next) {
-        sc = (store_client *)node->data;
+	sc = (store_client *) node->data;
 	if (sc->callback_data != NULL)
 	    return 1;
     }
@@ -73,7 +73,7 @@
     dlink_node *node;
     store_client *sc = NULL;
     for (node = mem->clients.head; node; node = node->next) {
-        sc = (store_client *)node->data;
+	sc = (store_client *) node->data;
 	if (sc->callback_data == data)
 	    return sc;
     }
@@ -129,7 +129,7 @@
     assert(mem);
 #if STORE_CLIENT_LIST_DEBUG
     if (storeClientListSearch(mem, data) != NULL)
-	assert(1==0); /* XXX die! */
+	assert(1 == 0);		/* XXX die! */
 #endif
     e->refcount++;
     mem->nclients++;
@@ -178,7 +178,7 @@
 
 /* copy bytes requested by the client */
 void
-storeClientCopy(store_client *sc,
+storeClientCopy(store_client * sc,
     StoreEntry * e,
     off_t seen_offset,
     off_t copy_offset,
@@ -317,9 +317,9 @@
 	/* What the client wants is in memory */
 	debug(20, 3) ("storeClientCopy3: Copying from memory\n");
 	sz = stmemCopy(&mem->data_hdr,
-  	sc->copy_offset, sc->copy_buf, sc->copy_size);
-        storeClientCallback(sc, sz);
-        return;
+	    sc->copy_offset, sc->copy_buf, sc->copy_size);
+	storeClientCallback(sc, sz);
+	return;
     }
     /* What the client wants is not in memory. Schedule a disk read */
     assert(STORE_DISK_CLIENT == sc->type);
@@ -467,7 +467,7 @@
 }
 
 int
-storeClientCopyPending(store_client *sc, StoreEntry * e, void *data)
+storeClientCopyPending(store_client * sc, StoreEntry * e, void *data)
 {
 #if STORE_CLIENT_LIST_DEBUG
     assert(sc == storeClientListSearch(e->mem_obj, data));
@@ -485,50 +485,50 @@
  * passed sc. Yet.
  */
 int
-storeUnregister(store_client *sc, StoreEntry * e, void *data)
+storeUnregister(store_client * sc, StoreEntry * e, void *data)
 {
     MemObject *mem = e->mem_obj;
 #if STORE_CLIENT_LIST_DEBUG
     assert(sc == storeClientListSearch(e->mem_obj, data));
 #endif
     if (mem == NULL)
-        return 0;
+	return 0;
     debug(20, 3) ("storeUnregister: called for '%s'\n", storeKeyText(e->key));
     if (sc == NULL)
-        return 0;
+	return 0;
     if (mem->clients.head == NULL)
-        return 0;
-    if (sc == (store_client *)mem->clients.head->data) {
-        /*
-         * If we are unregistering the _first_ client for this
-         * entry, then we have to reset the client FD to -1.
-         */
-        mem->fd = -1;
+	return 0;
+    if (sc == (store_client *) mem->clients.head->data) {
+	/*
+	 * If we are unregistering the _first_ client for this
+	 * entry, then we have to reset the client FD to -1.
+	 */
+	mem->fd = -1;
     }
     dlinkDelete(&sc->node, &mem->clients);
     mem->nclients--;
     if (e->store_status == STORE_OK && e->swap_status != SWAPOUT_DONE)
-        storeSwapOut(e);
+	storeSwapOut(e);
     if (sc->swapin_sio) {
-        storeClose(sc->swapin_sio);
-        cbdataUnlock(sc->swapin_sio);
-        sc->swapin_sio = NULL;
+	storeClose(sc->swapin_sio);
+	cbdataUnlock(sc->swapin_sio);
+	sc->swapin_sio = NULL;
     }
     if (NULL != sc->callback) {
-        /* callback with ssize = -1 to indicate unexpected termination */
-        debug(20, 3) ("storeUnregister: store_client for %s has a callback\n",
-            mem->url);
-        storeClientCallback(sc, -1);
+	/* callback with ssize = -1 to indicate unexpected termination */
+	debug(20, 3) ("storeUnregister: store_client for %s has a callback\n",
+	    mem->url);
+	storeClientCallback(sc, -1);
     }
 #if DELAY_POOLS
     delayUnregisterDelayIdPtr(&sc->delay_id);
 #endif
-    cbdataUnlock(sc->callback_data);    /* we're done with it now */
+    cbdataUnlock(sc->callback_data);	/* we're done with it now */
     /*assert(!sc->flags.disk_io_pending); */
     cbdataFree(sc);
     assert(e->lock_count > 0);
     if (mem->nclients == 0)
-        CheckQuickAbort(e);
+	CheckQuickAbort(e);
     return 1;
 }
 
@@ -542,7 +542,7 @@
     dlink_node *node;
 
     for (node = mem->clients.head; node; node = nx) {
-        sc = (store_client *)node->data;
+	sc = (store_client *) node->data;
 	nx = node->next;
 	if (sc->callback_data == NULL)	/* open slot */
 	    continue;
@@ -570,7 +570,7 @@
     debug(20, 3) ("InvokeHandlers: %s\n", storeKeyText(e->key));
     /* walk the entire list looking for valid callbacks */
     for (node = mem->clients.head; node; node = nx) {
-        sc = (store_client *)node->data;
+	sc = (store_client *) node->data;
 	nx = node->next;
 	debug(20, 3) ("InvokeHandlers: checking client #%d\n", i++);
 	if (sc->callback_data == NULL)
Index: squid/src/store_digest.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/store_digest.c,v
retrieving revision 1.1.1.3.6.1.2.1
retrieving revision 1.1.1.3.6.1.2.2
diff -u -r1.1.1.3.6.1.2.1 -r1.1.1.3.6.1.2.2
--- squid/src/store_digest.c	8 May 2000 18:02:08 -0000	1.1.1.3.6.1.2.1
+++ squid/src/store_digest.c	14 May 2000 23:22:20 -0000	1.1.1.3.6.1.2.2
@@ -1,5 +1,5 @@
 /*
- * $Id: store_digest.c,v 1.1.1.3.6.1.2.1 2000/05/08 18:02:08 hno Exp $
+ * $Id: store_digest.c,v 1.1.1.3.6.1.2.2 2000/05/14 23:22:20 hno Exp $
  *
  * DEBUG: section 71    Store Digest Manager
  * AUTHOR: Alex Rousskov
@@ -230,12 +230,10 @@
      * idea: skip objects that are going to be purged before the next
      * update.
      */
-#if 0 /* This code isn't applicable anymore, we can't fix it atm either :( */
-#if !HEAP_REPLACEMENT
+#if OLD_UNUSED_CODE		/* This code isn't applicable anymore, we can't fix it atm either :( */
     if ((squid_curtime + Config.digest.rebuild_period) - e->lastref > storeExpiredReferenceAge())
 	return 0;
 #endif
-#endif
     return 1;
 }
 
Index: squid/src/store_dir.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/store_dir.c,v
retrieving revision 1.1.1.3.10.6.2.1
retrieving revision 1.1.1.3.10.6.2.2
diff -u -r1.1.1.3.10.6.2.1 -r1.1.1.3.10.6.2.2
--- squid/src/store_dir.c	2 May 2000 22:50:29 -0000	1.1.1.3.10.6.2.1
+++ squid/src/store_dir.c	14 May 2000 23:22:20 -0000	1.1.1.3.10.6.2.2
@@ -1,6 +1,6 @@
 
 /*
- * $Id: store_dir.c,v 1.1.1.3.10.6.2.1 2000/05/02 22:50:29 hno Exp $
+ * $Id: store_dir.c,v 1.1.1.3.10.6.2.2 2000/05/14 23:22:20 hno Exp $
  *
  * DEBUG: section 47    Store Directory Routines
  * AUTHOR: Duane Wessels
@@ -36,8 +36,6 @@
 #include "squid.h"
 
 static int storeDirValidSwapDirSize(int, size_t);
-static void storeDirLRUWalkInitHead(SwapDir * sd);
-static void *storeDirLRUWalkNext(SwapDir * sd);
 
 void
 storeDirInit(void)
@@ -88,18 +86,18 @@
      * If the swapdir's max_obj_size is -1, then it definitely can
      */
     if (Config.cacheSwap.swapDirs[swapdir].max_objsize == -1)
-        return 1;
+	return 1;
     /*
      * Else, make sure that the max object size is larger than objsize
      */
     if (Config.cacheSwap.swapDirs[swapdir].max_objsize > objsize)
-        return 1;
+	return 1;
     else
-        return 0;
+	return 0;
 }
 
 
-#if UNUSED /* Squid-2..4.DEVEL3 code */
+#if UNUSED			/* Squid-2..4.DEVEL3 code */
 /*
  * This new selection scheme simply does round-robin on all SwapDirs.
  * A SwapDir is skipped if it is over the max_size (100%) limit.  If
@@ -179,7 +177,7 @@
  * we sort out the real usefulness of this algorithm.
  */
 int
-storeDirSelectSwapDir(const StoreEntry *e)
+storeDirSelectSwapDir(const StoreEntry * e)
 {
     size_t objsize;
     size_t least_size;
@@ -198,28 +196,28 @@
     least_size = Config.cacheSwap.swapDirs[0].cur_size;
     least_objsize = Config.cacheSwap.swapDirs[0].max_objsize;
     for (i = 0; i < Config.cacheSwap.n_configured; i++) {
-        SD = &Config.cacheSwap.swapDirs[i];
+	SD = &Config.cacheSwap.swapDirs[i];
 	SD->flags.selected = 0;
-        if (SD->flags.read_only)
-            continue;
-        /* Valid for object size check */
-        if (!storeDirValidSwapDirSize(i, objsize))
-            continue;
-        load = SD->checkobj(SD, e);
-        if (load < 0)
-	    continue;
-        if (SD->cur_size > SD->max_size)
-            continue;
-        if (load > least_load)
-            continue;
-        if ((least_objsize > 0) && (objsize > least_objsize))
-            continue;
-        /* Only use leastsize if the load is equal */
-        if ((load == least_load) && (SD->cur_size > least_size))
-            continue;
-        least_load = load;
-        least_size = SD->cur_size;
-        dirn = i;
+	if (SD->flags.read_only)
+	    continue;
+	/* Valid for object size check */
+	if (!storeDirValidSwapDirSize(i, objsize))
+	    continue;
+	load = SD->checkobj(SD, e);
+	if (load < 0)
+	    continue;
+	if (SD->cur_size > SD->max_size)
+	    continue;
+	if (load > least_load)
+	    continue;
+	if ((least_objsize > 0) && (objsize > least_objsize))
+	    continue;
+	/* Only use leastsize if the load is equal */
+	if ((load == least_load) && (SD->cur_size > least_size))
+	    continue;
+	least_load = load;
+	least_size = SD->cur_size;
+	dirn = i;
     }
 
     if (dirn >= 0)
@@ -261,14 +259,14 @@
     debug(20, 3) ("storeDirSwapLog: %s %s %d %08X\n",
 	swap_log_op_str[op],
 	storeKeyText(e->key),
-        e->swap_dirn,
+	e->swap_dirn,
 	e->swap_filen);
     sd = &Config.cacheSwap.swapDirs[e->swap_dirn];
     sd->log.write(sd, e, op);
 }
 
 void
-storeDirUpdateSwapSize(SwapDir *SD, size_t size, int sign)
+storeDirUpdateSwapSize(SwapDir * SD, size_t size, int sign)
 {
     int k = ((size + 1023) >> 10) * sign;
     SD->cur_size += k;
@@ -298,11 +296,11 @@
 
     /* Now go through each swapdir, calling its statfs routine */
     for (i = 0; i < Config.cacheSwap.n_configured; i++) {
-        storeAppendPrintf(sentry, "\n");
-        SD = &(Config.cacheSwap.swapDirs[i]);
-        storeAppendPrintf(sentry, "Store Directory #%d (%s): %s\n", i, SD->type,
-          storeSwapDir(i));
-        SD->statfs(SD, sentry);
+	storeAppendPrintf(sentry, "\n");
+	SD = &(Config.cacheSwap.swapDirs[i]);
+	storeAppendPrintf(sentry, "Store Directory #%d (%s): %s\n", i, SD->type,
+	    storeSwapDir(i));
+	SD->statfs(SD, sentry);
     }
 }
 
@@ -370,10 +368,9 @@
     struct timeval start;
     double dt;
     SwapDir *sd;
+    RemovalPolicyWalker **walkers;
     int dirn;
-#if HEAP_REPLACEMENT
-    int node;
-#endif
+    int notdone = 1;
     if (store_dirs_rebuilding) {
 	debug(20, 1) ("Not currently OK to rewrite swap log.\n");
 	debug(20, 1) ("storeDirWriteCleanLogs: Operation aborted.\n");
@@ -382,28 +379,24 @@
     debug(20, 1) ("storeDirWriteCleanLogs: Starting...\n");
     getCurrentTime();
     start = current_time;
+    walkers = xcalloc(Config.cacheSwap.n_configured, sizeof *walkers);
     for (dirn = 0; dirn < Config.cacheSwap.n_configured; dirn++) {
 	sd = &Config.cacheSwap.swapDirs[dirn];
-	if (sd->log.clean.open(sd) < 0) {
-	    debug(20, 1) ("log.clean.open() failed for dir #%d\n", sd->index);
+	if (sd->log.clean.start(sd) < 0) {
+	    debug(20, 1) ("log.clean.start() failed for dir #%d\n", sd->index);
 	    continue;
 	}
-	if (NULL == sd->log.clean.write)
-	    continue;
-#if HEAP_REPLACEMENT
-        if (NULL == sd->repl.heap.heap)
-            continue;
-#endif
-#if HEAP_REPLACEMENT
-        for (node = 0; node < heap_nodes(sd->repl.heap.heap); node++)
-#else
-	storeDirLRUWalkInitHead(sd);
-        while ((e = storeDirLRUWalkNext(sd)) != NULL)
-#endif
-        {
-#if HEAP_REPLACEMENT
-	    e = (StoreEntry *) heap_peep(sd->repl.heap.heap, node);
-#endif
+    }
+    while(notdone) {
+	notdone = 0;
+	for (dirn = 0; dirn < Config.cacheSwap.n_configured; dirn++) {
+	    sd = &Config.cacheSwap.swapDirs[dirn];
+	    if (NULL == sd->log.clean.write)
+		continue;
+	    e = sd->log.clean.nextentry(sd);
+	    if (!e)
+		continue;
+	    notdone = 1;
 	    if (e->swap_filen < 0)
 		continue;
 	    if (e->swap_status != SWAPOUT_DONE)
@@ -416,14 +409,17 @@
 		continue;
 	    if (EBIT_TEST(e->flags, ENTRY_SPECIAL))
 		continue;
-	    sd->log.clean.write(e, sd);
+	    sd->log.clean.write(sd, e);
 	    if ((++n & 0xFFFF) == 0) {
 		getCurrentTime();
 		debug(20, 1) ("  %7d entries written so far.\n", n);
 	    }
 	}
-        /* Flush */
-        sd->log.clean.write(NULL, sd);
+    }
+    /* Flush */
+    for (dirn = 0; dirn < Config.cacheSwap.n_configured; dirn++) {
+	sd = &Config.cacheSwap.swapDirs[dirn];
+        sd->log.clean.done(sd);
     }
     if (reopen)
 	storeDirOpenSwapLogs();
@@ -446,9 +442,9 @@
     SwapDir *SD;
 
     for (i = 0; i < Config.cacheSwap.n_configured; i++) {
-        SD = &Config.cacheSwap.swapDirs[i];
-        if (SD->sync != NULL)
-            SD->sync(SD);
+	SD = &Config.cacheSwap.swapDirs[i];
+	if (SD->sync != NULL)
+	    SD->sync(SD);
     }
 }
 
@@ -462,47 +458,8 @@
     SwapDir *SD;
 
     for (i = 0; i < Config.cacheSwap.n_configured; i++) {
-        SD = &Config.cacheSwap.swapDirs[i];
-        if (SD->callback != NULL)
-            SD->callback(SD);
+	SD = &Config.cacheSwap.swapDirs[i];
+	if (SD->callback != NULL)
+	    SD->callback(SD);
     }
 }
-
-#if 0 /* from Squid-2.4.DEVEL3 */
-void
-storeDirLRUDelete(StoreEntry * e)
-{
-    SwapDir *sd;
-    if (e->swap_filen < 0)
-	return;
-    sd = &Config.cacheSwap.swapDirs[e->swap_dirn];
-    dlinkDelete(&e->lru, &sd->repl.lru.list);
-}
-
-void
-storeDirLRUAdd(StoreEntry * e)
-{
-    SwapDir *sd;
-    if (e->swap_file_number < 0)
-	return;
-    sd = &Config.cacheSwap.swapDirs[e->swap_dirn];
-    dlinkAdd(e, &e->lru, &sd->repl.lru.list);
-}
-#endif /* from Squid-2.4.DEVEL3 */
-
-static void
-storeDirLRUWalkInitHead(SwapDir * sd)
-{
-    sd->repl.lru.walker = sd->repl.lru.list.head;
-}
-
-static void *
-storeDirLRUWalkNext(SwapDir * sd)
-{
-    void *p;
-    if (NULL == sd->repl.lru.walker)
-	return NULL;
-    p = sd->repl.lru.walker->data;
-    sd->repl.lru.walker = sd->repl.lru.walker->next;
-    return p;
-}
Index: squid/src/store_log.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/store_log.c,v
retrieving revision 1.1.1.2.10.2
retrieving revision 1.1.1.2.10.2.2.1
diff -u -r1.1.1.2.10.2 -r1.1.1.2.10.2.2.1
--- squid/src/store_log.c	20 Apr 2000 18:14:23 -0000	1.1.1.2.10.2
+++ squid/src/store_log.c	14 May 2000 23:22:20 -0000	1.1.1.2.10.2.2.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: store_log.c,v 1.1.1.2.10.2 2000/04/20 18:14:23 hno Exp $
+ * $Id: store_log.c,v 1.1.1.2.10.2.2.1 2000/05/14 23:22:20 hno Exp $
  *
  * DEBUG: section 20    Storage Manager Logging Functions
  * AUTHOR: Duane Wessels
@@ -71,7 +71,7 @@
 	(int) current_time.tv_sec,
 	(int) current_time.tv_usec / 1000,
 	storeLogTags[tag],
-        e->swap_dirn,
+	e->swap_dirn,
 	e->swap_filen,
 	reply->sline.status,
 	(int) reply->date,
Index: squid/src/store_swapin.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/store_swapin.c,v
retrieving revision 1.1.1.3.10.4
retrieving revision 1.1.1.3.10.4.2.1
diff -u -r1.1.1.3.10.4 -r1.1.1.3.10.4.2.1
--- squid/src/store_swapin.c	20 Apr 2000 18:14:23 -0000	1.1.1.3.10.4
+++ squid/src/store_swapin.c	14 May 2000 23:22:20 -0000	1.1.1.3.10.4.2.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: store_swapin.c,v 1.1.1.3.10.4 2000/04/20 18:14:23 hno Exp $
+ * $Id: store_swapin.c,v 1.1.1.3.10.4.2.1 2000/05/14 23:22:20 hno Exp $
  *
  * DEBUG: section 20    Storage Manager Swapin Functions
  * AUTHOR: Duane Wessels
@@ -62,7 +62,7 @@
     debug(20, 3) ("storeSwapInStart: Opening fileno %08X\n",
 	e->swap_filen);
     sc->swapin_sio = storeOpen(e, storeSwapInFileNotify, storeSwapInFileClosed,
-      sc);
+	sc);
     cbdataLock(sc->swapin_sio);
 }
 
@@ -85,11 +85,11 @@
 static void
 storeSwapInFileNotify(void *data, int errflag, storeIOState * sio)
 {
-  store_client *sc = data;
-  StoreEntry *e = sc->entry;
- 
-  debug(1, 3) ("storeSwapInFileNotify: changing %d/%d to %d/%d\n", e->swap_filen, e->swap_dirn, sio->swap_filen, sio->swap_dirn);
+    store_client *sc = data;
+    StoreEntry *e = sc->entry;
+
+    debug(1, 3) ("storeSwapInFileNotify: changing %d/%d to %d/%d\n", e->swap_filen, e->swap_dirn, sio->swap_filen, sio->swap_dirn);
 
-  e->swap_filen = sio->swap_filen;
-  e->swap_dirn = sio->swap_dirn;
+    e->swap_filen = sio->swap_filen;
+    e->swap_dirn = sio->swap_dirn;
 }
